//This will compile on Dev-C++ 5.4.2

//Standard C++ includes.
#include <locale> // this sets locale.
#include <cstdio> // C Standard Input/Output Library
#include <iostream> // C++ Input/Output Library
#include <iomanip> // C++ I/O Manipulation Library
#include <cmath> //  C Mathematical Function Library (used for powers and exponents, etc)
#include <string> // String Library
#include <sstream> // Stream Library
#include <fstream> // file I/O Library
#include <cstring> // String Library
#include <stdlib.h> // RANDOM NUMBER LIBRARY

//IRON STORM SSF v0.12 beta R4 Binary Savegame editor.
//Programmed October 2015 by Ryan Crierie
//at www.alternatewars.com

using namespace std;

unsigned char EditOneByte(double Offset, int ChangeTo)
{
char ChangedByte = ChangeTo;	// We have to cast internally the integer "ChangeTo" number into a character in order to convert it from say '250' into proper hexadecimal. so that what we want written will be written.

FILE* fileHandle = fopen("IRONSTRM_00.bin", "rb+"); // r+ if you need char mode
fseek(fileHandle, Offset, SEEK_SET);
fwrite(&ChangedByte, 1, 1, fileHandle);
fclose(fileHandle);
}

int ReadOneByte(double Offset)
{
FILE* fileHandle = fopen("IRONSTRM_00.bin", "rb+"); // r+ if you need char mode
fseek(fileHandle, Offset, SEEK_SET);
int Output = fgetc(fileHandle); // fgetc automatically changes it to an integer anyway, so...
fclose(fileHandle);
return (Output);
}

void CopyRecord(double RecordNumberIn, double RecordNumberOut)
{

int InputOffset = 0;
if(RecordNumberIn == 1){InputOffset = 21;}
if(RecordNumberIn >= 2){InputOffset = 21 + ( (RecordNumberIn * 36) - 36);}

int OutputOffset = 0;
if(RecordNumberOut == 1){OutputOffset = 21;}
if(RecordNumberOut >= 2){OutputOffset = 21 + ( (RecordNumberOut * 36) - 36);}

std::cout <<  std::endl;
std::cout << "Starting Offset for Input is: " << InputOffset << std::endl;
std::cout << "Starting Offset for Output is: " << OutputOffset << std::endl;
std::cout <<  std::endl;

FILE* fileHandle = fopen("IRONSTRM_00.bin", "rb+"); // r+ if you need char mode

int ByteCounter = 1; // Initalize Record Counter.
while(ByteCounter <= 36)
{
fseek(fileHandle, InputOffset, SEEK_SET); // Move to the Required Pointer Area
int CopiedCharacter = fgetc(fileHandle); // Copy that Character into Memory.
std::cout << "Byte " << ByteCounter << " of Unit " << RecordNumberIn << " With A Value of " << CopiedCharacter << " Copied into Memory." << std::endl;
EditOneByte(OutputOffset, CopiedCharacter); //Write that Character into File.
std::cout << "Byte " << ByteCounter << " of Unit " << RecordNumberOut << " Written into file."<< std::endl;
ByteCounter++; // Increment Counter by One.
InputOffset++; // Increment By One.
OutputOffset++; // Increment by One.
}

//Now that we're done copying, we need to move the new unit up and to the right one hex; 
//so it doesn't conflict with the new unit.
//First We Reset Our Offsets to the new One and change offset to point to the Y Location.

std::cout <<  std::endl;

std::cout << "Changing X Location of Copied Unit so it doesn't conflict with Existing Unit."<< std::endl;
if(RecordNumberIn == 1){InputOffset = 33;}
if(RecordNumberIn >= 2){InputOffset = 33 + ( (RecordNumberIn * 36) - 36);}

if(RecordNumberOut == 1){OutputOffset = 33;}
if(RecordNumberOut >= 2){OutputOffset = 33 + ( (RecordNumberOut * 36) - 36);}

std::cout <<  std::endl;
std::cout << "Starting Offset for Input is: " << InputOffset << std::endl;
std::cout << "Starting Offset for Output is: " << OutputOffset << std::endl;
std::cout <<  std::endl;

fseek(fileHandle, InputOffset, SEEK_SET); // Move to the Required Pointer Area
int CopiedCharacter = fgetc(fileHandle); // Copy that Character into Memory.
CopiedCharacter++; // Increment the X by 1.
std::cout << "X Loc of Unit " << RecordNumberIn << " Copied into Memory."<< std::endl;
EditOneByte(OutputOffset, CopiedCharacter); //Write that Character into File.
std::cout << "X Loc of Unit " << RecordNumberOut << " Written into file."<< std::endl;

std::cout <<  std::endl;

std::cout << "Changing Y Location of Copied Unit so it doesn't conflict with Existing Unit."<< std::endl;
if(RecordNumberIn == 1){InputOffset = 34;}
if(RecordNumberIn >= 2){InputOffset = 34 + ( (RecordNumberIn * 36) - 36);}

if(RecordNumberOut == 1){OutputOffset = 34;}
if(RecordNumberOut >= 2){OutputOffset = 34 + ( (RecordNumberOut * 36) - 36);}

std::cout <<  std::endl;
std::cout << "Starting Offset for Input is: " << InputOffset << std::endl;
std::cout << "Starting Offset for Output is: " << OutputOffset << std::endl;
std::cout <<  std::endl;

fseek(fileHandle, InputOffset, SEEK_SET); // Move to the Required Pointer Area
CopiedCharacter = fgetc(fileHandle); // Copy that Character into Memory.
CopiedCharacter--; // Decrement the Y by 1.
std::cout << "Y Loc of Unit " << RecordNumberIn << " Copied into Memory."<< std::endl;
EditOneByte(OutputOffset, CopiedCharacter); //Write that Character into File.
std::cout << "Y Loc of Unit " << RecordNumberOut << " Written into file."<< std::endl;

fclose(fileHandle);

}

void ChangeUnitToDinosaur(double RecordNumberIn, int XLocation, int YLocation)
{
int InputOffset = 0;
if(RecordNumberIn == 1){InputOffset = 21;}
if(RecordNumberIn >= 2){InputOffset = 21 + ( (RecordNumberIn * 36) - 36);}

std::cout <<  std::endl;
std::cout << "Starting Offset for Input is: " << InputOffset << std::endl;
std::cout <<  std::endl;

FILE* fileHandle = fopen("IRONSTRM_00.bin", "rb+"); // r+ if you need char mode
fseek(fileHandle, InputOffset, SEEK_SET); // Move to the Required Pointer Area

EditOneByte( (InputOffset+0),	1	); // Write Value into File Here
EditOneByte( (InputOffset+1),	180	); // Write Value into File Here
EditOneByte( (InputOffset+2),	0	); // Write Value into File Here
EditOneByte( (InputOffset+3),	0	); // Write Value into File Here
EditOneByte( (InputOffset+4),	6	); // Write Value into File Here
EditOneByte( (InputOffset+5),	0	); // Write Value into File Here
EditOneByte( (InputOffset+6),	208	); // Write Value into File Here
EditOneByte( (InputOffset+7),	24	); // Write Value into File Here
EditOneByte( (InputOffset+8),	0	); // Write Value into File Here
EditOneByte( (InputOffset+9),	10	); // Write Value into File Here
EditOneByte( (InputOffset+10),	140	); // Write Value into File Here
EditOneByte( (InputOffset+11),	0	); // Write Value into File Here
EditOneByte( (InputOffset+12),	0	); // Write Value into File Here
EditOneByte( (InputOffset+13),	XLocation	); // Write Value into File Here
EditOneByte( (InputOffset+14),	YLocation	); // Write Value into File Here
EditOneByte( (InputOffset+15),	0	); // Write Value into File Here
EditOneByte( (InputOffset+16),	1	); // Write Value into File Here
EditOneByte( (InputOffset+17),	117	); // Write Value into File Here
EditOneByte( (InputOffset+18),	0	); // Write Value into File Here
EditOneByte( (InputOffset+19),	0	); // Write Value into File Here
EditOneByte( (InputOffset+20),	0	); // Write Value into File Here
EditOneByte( (InputOffset+21),	0	); // Write Value into File Here
EditOneByte( (InputOffset+22),	0	); // Write Value into File Here
EditOneByte( (InputOffset+23),	0	); // Write Value into File Here
EditOneByte( (InputOffset+24),	99	); // Write Value into File Here
EditOneByte( (InputOffset+25),	0	); // Write Value into File Here
EditOneByte( (InputOffset+26),	0	); // Write Value into File Here
EditOneByte( (InputOffset+27),	0	); // Write Value into File Here
EditOneByte( (InputOffset+28),	255	); // Write Value into File Here
EditOneByte( (InputOffset+29),	255	); // Write Value into File Here
EditOneByte( (InputOffset+30),	255	); // Write Value into File Here
EditOneByte( (InputOffset+31),	255	); // Write Value into File Here

fclose(fileHandle);
}

void ChangeUnitToMobileInfantry(double RecordNumberIn, int XLocation, int YLocation)
{
int InputOffset = 0;
if(RecordNumberIn == 1){InputOffset = 21;}
if(RecordNumberIn >= 2){InputOffset = 21 + ( (RecordNumberIn * 36) - 36);}

std::cout <<  std::endl;
std::cout << "Starting Offset for Input is: " << InputOffset << std::endl;
std::cout <<  std::endl;

FILE* fileHandle = fopen("IRONSTRM_00.bin", "rb+"); // r+ if you need char mode
fseek(fileHandle, InputOffset, SEEK_SET); // Move to the Required Pointer Area

EditOneByte( (InputOffset+0),	1	); // Write Value into File Here
EditOneByte( (InputOffset+1),	181	); // Write Value into File Here
EditOneByte( (InputOffset+2),	0	); // Write Value into File Here
EditOneByte( (InputOffset+3),	0	); // Write Value into File Here
EditOneByte( (InputOffset+4),	6	); // Write Value into File Here
EditOneByte( (InputOffset+5),	0	); // Write Value into File Here
EditOneByte( (InputOffset+6),	214	); // Write Value into File Here
EditOneByte( (InputOffset+7),	248	); // Write Value into File Here
EditOneByte( (InputOffset+8),	0	); // Write Value into File Here
EditOneByte( (InputOffset+9),	10	); // Write Value into File Here
EditOneByte( (InputOffset+10),	60	); // Write Value into File Here
EditOneByte( (InputOffset+11),	30	); // Write Value into File Here
EditOneByte( (InputOffset+12),	0	); // Write Value into File Here
EditOneByte( (InputOffset+13),	XLocation	); // Write Value into File Here
EditOneByte( (InputOffset+14),	YLocation	); // Write Value into File Here
EditOneByte( (InputOffset+15),	0	); // Write Value into File Here
EditOneByte( (InputOffset+16),	0	); // Write Value into File Here
EditOneByte( (InputOffset+17),	243	); // Write Value into File Here
EditOneByte( (InputOffset+18),	0	); // Write Value into File Here
EditOneByte( (InputOffset+19),	0	); // Write Value into File Here
EditOneByte( (InputOffset+20),	0	); // Write Value into File Here
EditOneByte( (InputOffset+21),	0	); // Write Value into File Here
EditOneByte( (InputOffset+22),	0	); // Write Value into File Here
EditOneByte( (InputOffset+23),	0	); // Write Value into File Here
EditOneByte( (InputOffset+24),	12	); // Write Value into File Here
EditOneByte( (InputOffset+25),	0	); // Write Value into File Here
EditOneByte( (InputOffset+26),	0	); // Write Value into File Here
EditOneByte( (InputOffset+27),	0	); // Write Value into File Here
EditOneByte( (InputOffset+28),	255	); // Write Value into File Here
EditOneByte( (InputOffset+29),	255	); // Write Value into File Here
EditOneByte( (InputOffset+30),	255	); // Write Value into File Here
EditOneByte( (InputOffset+31),	255	); // Write Value into File Here

fclose(fileHandle);
}

void ChangeUnitToUFO(double RecordNumberIn, int XLocation, int YLocation)
{
int InputOffset = 0;
if(RecordNumberIn == 1){InputOffset = 21;}
if(RecordNumberIn >= 2){InputOffset = 21 + ( (RecordNumberIn * 36) - 36);}

std::cout <<  std::endl;
std::cout << "Starting Offset for Input is: " << InputOffset << std::endl;
std::cout <<  std::endl;

FILE* fileHandle = fopen("IRONSTRM_00.bin", "rb+"); // r+ if you need char mode
fseek(fileHandle, InputOffset, SEEK_SET); // Move to the Required Pointer Area

EditOneByte( (InputOffset+0),	1	); // Write Value into File Here
EditOneByte( (InputOffset+1),	179	); // Write Value into File Here
EditOneByte( (InputOffset+2),	0	); // Write Value into File Here
EditOneByte( (InputOffset+3),	0	); // Write Value into File Here
EditOneByte( (InputOffset+4),	6	); // Write Value into File Here
EditOneByte( (InputOffset+5),	0	); // Write Value into File Here
EditOneByte( (InputOffset+6),	190	); // Write Value into File Here
EditOneByte( (InputOffset+7),	56	); // Write Value into File Here
EditOneByte( (InputOffset+8),	0	); // Write Value into File Here
EditOneByte( (InputOffset+9),	10	); // Write Value into File Here
EditOneByte( (InputOffset+10),	150	); // Write Value into File Here
EditOneByte( (InputOffset+11),	100	); // Write Value into File Here
EditOneByte( (InputOffset+12),	0	); // Write Value into File Here
EditOneByte( (InputOffset+13),	XLocation	); // Write Value into File Here
EditOneByte( (InputOffset+14),	YLocation	); // Write Value into File Here
EditOneByte( (InputOffset+15),	0	); // Write Value into File Here
EditOneByte( (InputOffset+16),	0	); // Write Value into File Here
EditOneByte( (InputOffset+17),	94	); // Write Value into File Here
EditOneByte( (InputOffset+18),	0	); // Write Value into File Here
EditOneByte( (InputOffset+19),	139	); // Write Value into File Here
EditOneByte( (InputOffset+20),	0	); // Write Value into File Here
EditOneByte( (InputOffset+21),	0	); // Write Value into File Here
EditOneByte( (InputOffset+22),	0	); // Write Value into File Here
EditOneByte( (InputOffset+23),	0	); // Write Value into File Here
EditOneByte( (InputOffset+24),	4	); // Write Value into File Here
EditOneByte( (InputOffset+25),	4	); // Write Value into File Here
EditOneByte( (InputOffset+26),	0	); // Write Value into File Here
EditOneByte( (InputOffset+27),	0	); //Write Value into File Here
EditOneByte( (InputOffset+28),	255	); //Write Value into File Here
EditOneByte( (InputOffset+29),	255	); //Write Value into File Here
EditOneByte( (InputOffset+30),	255	); //Write Value into File Here
EditOneByte( (InputOffset+31),	255	); //Write Value into File Here

fclose(fileHandle);
}

int main() // main function.

{

std::cout << "********************************" << std::endl;
std::cout << "* IRON STORM SAVE FILE EDITOR  *" << std::endl;
std::cout << "*  by Ryan Crierie; Oct. 2015  *" << std::endl;
std::cout << "********************************" << std::endl;
std::cout << std::endl;
std::cout << "1.) Boost all XP in Side 1's Units to 250." << std::endl;
std::cout << "2.) Randomly generate Training/XP for Side 1's Units." << std::endl;
std::cout << "3.) Remove MOVED flags from Side 1's Units." << std::endl;
std::cout << "4.) Set Flags to WIN Scenario Instantly at end of turn." << std::endl;
std::cout << "5.) Set Side 1's Money to $15,000." << std::endl;
std::cout << "6.) Set Side 1's Money to $79,810." << std::endl;
std::cout << "" << std::endl;
std::cout << "7.) Copy Side 1's Units to other Unit Slots." << std::endl;
// std::cout << "8.) Create Secret Units in Side 1's List." << std::endl; Not Working Currently
std::cout << std::endl;
std::cout << "Choose Function to execute: ";
double MainMenuChoice;
std::cin >> MainMenuChoice;

if(MainMenuChoice == 1)
{
//BOOST XP to 250 for all units that exist.

	//begin ground unit loop
	
	int ManpowerChecker = 0;
	int GroundCounter = 1;
	int GroundManpowerOffset = 29;
	int GroundExperienceOffset = 28;
	
	while(GroundCounter < 36)
	{
		ManpowerChecker = ReadOneByte(GroundManpowerOffset); // Read Manpower Byte for Ground Unit.
		if(ManpowerChecker >= 1)
		{
		EditOneByte(GroundExperienceOffset, 250); // Edit Ground Unit XP to 250.
		GroundCounter++;
		GroundManpowerOffset+=36;
		GroundExperienceOffset+=36;
		}
		if(ManpowerChecker == 0)
		{
		std::cout << "Ground Unit " << GroundCounter << " Doesn't Exist!" << std::endl;
		GroundCounter++;
		GroundManpowerOffset+=36;
		GroundExperienceOffset+=36;
		}
		
	}
	
	
	int AirCounter = 1;
	int AirManpowerOffset = 1181;
	int AirExperienceOffset = 1180;
	
	while(AirCounter < 36)
	{
		ManpowerChecker = ReadOneByte(AirManpowerOffset); // Read Manpower Byte for Air Unit.
		if(ManpowerChecker >= 1)
		{
		EditOneByte(AirExperienceOffset, 250); // Edit Air Unit XP to 250.
		AirCounter++;
		AirManpowerOffset+=36;
		AirExperienceOffset+=36;
		}
		if(ManpowerChecker == 0)
		{
		std::cout << "Air Unit " << AirCounter << " Doesn't Exist!" << std::endl;
		AirCounter++;
		AirManpowerOffset+=36;
		AirExperienceOffset+=36;
		}
		
	}	
	
	
	int SeaCounter = 1;
	int SeaManpowerOffset = 2333;
	int SeaExperienceOffset = 2332;
	
	while(SeaCounter < 16)
	{
		ManpowerChecker = ReadOneByte(SeaManpowerOffset); // Read Manpower Byte for Sea Unit.
		if(ManpowerChecker >= 1)
		{
		EditOneByte(SeaExperienceOffset, 250); // Edit Sea Unit XP to 250.
		SeaCounter++;
		SeaManpowerOffset+=36;
		SeaExperienceOffset+=36;
		}
		if(ManpowerChecker == 0)
		{
		std::cout << "Sea Unit " << SeaCounter << " Doesn't Exist!" << std::endl;
		SeaCounter++;
		SeaManpowerOffset+=36;
		SeaExperienceOffset+=36;
		}
		
	}	
	
}

if(MainMenuChoice == 2) //Randomly Generate XP/TRAINING.
{

int MinRand = 0; // Initalize
int MaxRand = 0; // Initalize

//Pick High/Mod/Low Experience Level.
std::cout << "**PICK GENERAL FORCE EXPERIENCE LEVEL**" << std::endl;
std::cout << "1.) Level 1 (0-50 XP)" << std::endl;
std::cout << "2.) Level 2 (40-90 XP)" << std::endl;
std::cout << "3.) Level 3 (80-130 XP)" << std::endl;
std::cout << "4.) Level 4 (120-170 XP) (1941 Era German / 1945 Era US Buyable)" << std::endl;
std::cout << "5.) Level 5 (160-210 XP)" << std::endl;
std::cout << "6.) Level 6 (200-250 XP)" << std::endl;

double XPLevelChoice;
std::cin >> XPLevelChoice;

if(XPLevelChoice == 1)
{
MinRand = 0;
MaxRand = 50;
}
if(XPLevelChoice == 2)
{
MinRand = 40;
MaxRand = 90;
}
if(XPLevelChoice == 3)
{
MinRand = 80;
MaxRand = 130;
}
if(XPLevelChoice == 4)
{
MinRand = 120;
MaxRand = 170;
}
if(XPLevelChoice == 5)
{
MinRand = 160;
MaxRand = 210;
}
if(XPLevelChoice == 6)
{
MinRand = 200;
MaxRand = 250;
}

	int ManpowerChecker = 0;
	int GroundCounter = 1;
	int GroundManpowerOffset = 29;
	int GroundTrainingOffset = 30;
	int GroundExperienceOffset = 28;
	
	while(GroundCounter < 36)
	{
		ManpowerChecker = ReadOneByte(GroundManpowerOffset); // Read Manpower Byte for Ground Unit.
		if(ManpowerChecker >= 1)
		{
		EditOneByte(GroundExperienceOffset, rand()%(MaxRand-MinRand)+MinRand); // Edit Ground Unit XP Randomly.
		EditOneByte(GroundTrainingOffset, rand()%(MaxRand-MinRand)+MinRand); // Edit Ground Unit Training.
		GroundCounter++;
		GroundManpowerOffset+=36;
		GroundExperienceOffset+=36;
		GroundTrainingOffset+=36;
		}
		if(ManpowerChecker == 0)
		{
		std::cout << "Ground Unit " << GroundCounter << " Doesn't Exist!" << std::endl;
		GroundCounter++;
		GroundManpowerOffset+=36;
		GroundTrainingOffset+=36;
		GroundExperienceOffset+=36;
		}
		
	}
	
	
	int AirCounter = 1;
	int AirManpowerOffset = 1181;
	int AirExperienceOffset = 1180;
	int AirTrainingOffset = 1182;
	
	while(AirCounter < 36)
	{
		ManpowerChecker = ReadOneByte(AirManpowerOffset); // Read Manpower Byte for Air Unit.
		if(ManpowerChecker >= 1)
		{
		EditOneByte(AirExperienceOffset, rand()%(MaxRand-MinRand)+MinRand); // Edit Air Unit XP Randomly.
		EditOneByte(AirTrainingOffset, rand()%(MaxRand-MinRand)+MinRand); // Edit Air Unit Training.
		AirCounter++;
		AirManpowerOffset+=36;
		AirExperienceOffset+=36;
		AirTrainingOffset+=36;
		}
		if(ManpowerChecker == 0)
		{
		std::cout << "Air Unit " << AirCounter << " Doesn't Exist!" << std::endl;
		AirCounter++;
		AirManpowerOffset+=36;
		AirExperienceOffset+=36;
		AirTrainingOffset+=36;
		}
		
	}	
	
	
	int SeaCounter = 1;
	int SeaManpowerOffset = 2333;
	int SeaExperienceOffset = 2332;
	int SeaTrainingOffset = 2334;
		
	while(SeaCounter < 16)
	{
		ManpowerChecker = ReadOneByte(SeaManpowerOffset); // Read Manpower Byte for Sea Unit.
		if(ManpowerChecker >= 1)
		{
		EditOneByte(SeaExperienceOffset, rand()%(MaxRand-MinRand)+MinRand); // Edit Sea Unit XP Randomly.
		EditOneByte(SeaTrainingOffset, rand()%(MaxRand-MinRand)+MinRand); // Edit Sea Unit Training.
		SeaCounter++;
		SeaManpowerOffset+=36;
		SeaExperienceOffset+=36;
		SeaTrainingOffset+=36;
		}
		if(ManpowerChecker == 0)
		{
		std::cout << "Sea Unit " << SeaCounter << " Doesn't Exist!" << std::endl;
		SeaCounter++;
		SeaManpowerOffset+=36;
		SeaExperienceOffset+=36;
		SeaTrainingOffset+=36;
		}
		
	}	
	
}

if(MainMenuChoice == 3) //REMOVE MOVED FLAG FROM ALL UNITS FOR SIDE 1.
{
	int ManpowerChecker = 0;
	
	int GroundManpowerOffset = 29;
	int GroundCounter = 1;
	int GroundMovedFLAG = 52;
	
	while(GroundCounter < 36)
	{
		ManpowerChecker = ReadOneByte(GroundManpowerOffset); // Read Manpower Byte for Ground Unit.
		if(ManpowerChecker >= 1)
		{
		EditOneByte(GroundMovedFLAG, 96); // Mark Unmoved.
		GroundCounter++;
		GroundManpowerOffset+=36;
		GroundMovedFLAG+=36;
		}
		if(ManpowerChecker == 0)
		{
		std::cout << "Ground Unit " << GroundCounter << " Doesn't Exist!" << std::endl;
		GroundCounter++;
		GroundManpowerOffset+=36;
		GroundMovedFLAG+=36;
		}
		
	}
	
	
	int AirCounter = 1;
	int AirManpowerOffset = 1181;
	int AirMovedFLAG = 1204;
	
	while(AirCounter < 36)
	{
		ManpowerChecker = ReadOneByte(AirManpowerOffset); // Read Manpower Byte for Air Unit.
		if(ManpowerChecker >= 1)
		{
		EditOneByte(AirMovedFLAG, 96);  // Mark Unmoved.
		AirCounter++;
		AirManpowerOffset+=36;
		AirMovedFLAG+=36;
		}
		if(ManpowerChecker == 0)
		{
		std::cout << "Air Unit " << AirCounter << " Doesn't Exist!" << std::endl;
		AirCounter++;
		AirManpowerOffset+=36;
		AirMovedFLAG+=36;
		}
		
	}	
	
	
	int SeaCounter = 1;
	int SeaManpowerOffset = 2333;
	int SeaMovedFLAG = 2332;
	
	while(SeaCounter < 16)
	{
		ManpowerChecker = ReadOneByte(SeaManpowerOffset); // Read Manpower Byte for Sea Unit.
		if(ManpowerChecker >= 1)
		{
		EditOneByte(SeaMovedFLAG, 96); // Edit Sea Unit XP to 250.
		SeaCounter++;
		SeaManpowerOffset+=36;
		SeaMovedFLAG+=36;
		}
		if(ManpowerChecker == 0)
		{
		std::cout << "Sea Unit " << SeaCounter << " Doesn't Exist!" << std::endl;
		SeaCounter++;
		SeaManpowerOffset+=36;
		SeaMovedFLAG+=36;
		}
		
	}	
	
}

if(MainMenuChoice == 4)
{
//SET FLAGS TO WIN.

EditOneByte(19774, 255); // Set Side 1 Alliance 1
EditOneByte(19775, 255); // Set Side 1 Alliance 2
EditOneByte(19776, 255); // Set Side 1 Alliance 3
EditOneByte(19777, 255); // Set Side 1 Alliance 4
EditOneByte(19778, 255); // Set Side 1 Alliance 5
	
EditOneByte(19798, 255); // Set Side 2 Alliance 1
EditOneByte(19799, 255); // Set Side 2 Alliance 2
EditOneByte(19800, 255); // Set Side 2 Alliance 3
EditOneByte(19801, 255); // Set Side 2 Alliance 4
EditOneByte(19802, 255); // Set Side 2 Alliance 5
	
EditOneByte(19822, 255); // Set Side 3 Alliance 1
EditOneByte(19823, 255); // Set Side 3 Alliance 2
EditOneByte(19824, 255); // Set Side 3 Alliance 3
EditOneByte(19825, 255); // Set Side 3 Alliance 4
EditOneByte(19826, 255); // Set Side 3 Alliance 5
	
EditOneByte(19846, 255); // Set Side 4 Alliance 1
EditOneByte(19847, 255); // Set Side 4 Alliance 2
EditOneByte(19848, 255); // Set Side 4 Alliance 3
EditOneByte(19849, 255); // Set Side 4 Alliance 4
EditOneByte(19850, 255); // Set Side 4 Alliance 5

EditOneByte(19870, 255); // Set Side 5 Alliance 1
EditOneByte(19871, 255); // Set Side 5 Alliance 2
EditOneByte(19872, 255); // Set Side 5 Alliance 3
EditOneByte(19873, 255); // Set Side 5 Alliance 4
EditOneByte(19874, 255); // Set Side 5 Alliance 5

std::cout << "Alliance Flags set to win at end of the current turn." << std::endl;

}

if(MainMenuChoice == 5)
{
//SET MONEY TO $15,000
	
EditOneByte(19765, 0);
EditOneByte(19766, 58);  
EditOneByte(19767, 152); 
EditOneByte(19768, 0); 
std::cout << "Money For Player 1 Set to $15,000." << std::endl;

}


if(MainMenuChoice == 6)
{
//SET MONEY TO $79,810
	
EditOneByte(19765, 1);
EditOneByte(19766, 55);  
EditOneByte(19767, 194); 
EditOneByte(19768, 0); 
std::cout << "Money For Player 1 Set to $79,810." << std::endl;
	
}

if(MainMenuChoice == 7)
{
std::cout << std::endl;
std::cout << "Copy Function Selected" << std::endl;
std::cout << std::endl;
std::cout << "Ground: Units 1 to 32" << std::endl;
std::cout << "Air: Units 33 to 65" << std::endl;
std::cout << "Sea: Units 66 to 82" << std::endl;
std::cout << std::endl; 
std::cout << "Input Record Slot to Copy From:" << std::endl;
double SlotCopyFrom;
std::cin >> SlotCopyFrom;
std::cout << "Input Record Slot to Copy To:" << std::endl;
double SlotCopyTo;
std::cin >> SlotCopyTo;
CopyRecord(SlotCopyFrom, SlotCopyTo);
}

if(MainMenuChoice == 8)
{
std::cout << std::endl;
std::cout << "CREATE SECRET UNITS IN SIDE 1." << std::endl;
std::cout << std::endl;
std::cout << "Ground: Units 1 to 32" << std::endl;
std::cout << "Air: Units 33 to 65" << std::endl;
std::cout << "Sea: Units 66 to 82" << std::endl;

std::cout << std::endl; 
std::cout << "Input Unit Slot to Change:" << std::endl;
double UnitChange;
std::cin >> UnitChange;
std::cout << std::endl; 

std::cout << "UNIT TO CHANGE TO" << std::endl;
std::cout << "1.) Mechanized (Mobile) Infantry (LAND)" << std::endl;
std::cout << "2.) Dinosaur (LAND)" << std::endl;
std::cout << "3.) NAZI UFO (AIR)" << std::endl;
double UnitType;
std::cin >> UnitType;
std::cout << std::endl; 

std::cout << "INPUT NEW X LOCATION" << std::endl;
double UnitX;
std::cin >> UnitX;
std::cout << std::endl; 

std::cout << "INPUT NEW Y LOCATION" << std::endl;
double UnitY;
std::cin >> UnitY;
std::cout << std::endl; 

if(UnitType==1){ChangeUnitToMobileInfantry(UnitChange, UnitX, UnitY);}
if(UnitType==2){ChangeUnitToDinosaur(UnitChange, UnitX, UnitY);}
if(UnitType==3){ChangeUnitToUFO(UnitChange, UnitX, UnitY);}
}

std::cout << "All Functions Executed and done." << std::endl;
std::cout << "Awaiting your command, master *BREEP*" << std::endl;

std::getchar(); //Hold for Keypress.
std::getchar(); //Hold for Keypress.

return(0); // Ends Program.}
}
